"""
__author__ = '霍格沃兹测试开发学社'
__desc__ = '更多测试开发技术探讨，请访问：https://ceshiren.com/t/topic/15860'
"""
import pytest

from src.fight_game import fight


def setup_module():
    print("开始测试")

def teardown_module():
    print("结束测试")

def setup_function():
    print("开始战斗")

def teardown_function():
    print("战斗结束")


@pytest.mark.run(order=2)
def test_smoke_case():
    '''
    冒烟用例，简单验证函数基本功能
    :return:
    '''
    # 定义英雄属性（测试数据）
    EZ_hp = 100
    EZ_power = 20
    Jinx_hp = 80
    Jinx_power = 30
    # 测试步骤
    result = fight(EZ_hp, EZ_power, Jinx_hp, Jinx_power)
    # result 实际结果？
    # 断言
    # 确定预期结果：得到的 result 是三种结果之一
    assert result in ["EZ 赢了", "Jinx 赢了", "平局"]
    assert result == "Jinx 赢了"


@pytest.mark.run(order=1)
@pytest.mark.parametrize(
    "EZ_hp, EZ_power, Jinx_hp, Jinx_power, expected",
    [
        [100, 50, 100, 40, "EZ 赢了"],
        [100, 30, 100, 50, "Jinx 赢了"],
        [100, 20, 100, 20, "平局"]
    ]
)
def test_fight_with_params(EZ_hp, EZ_power, Jinx_hp, Jinx_power, expected):
    '''
    参数化测试：验证多种输入场景，测试步骤相同，测试数据不同
    :return:
    '''
    # 测试步骤
    result = fight(EZ_hp, EZ_power, Jinx_hp, Jinx_power)
    # 断言，对比预期结果和实际结果是否一致
    assert result == expected